<?php
namespace Concrete\Package\ToessLabRobotsTxt;

use Concrete\Core\Asset\Asset;
use Concrete\Core\Asset\AssetList;
use Concrete\Core\Package\Package;
use Concrete\Core\Page\Page;
use Concrete\Core\Page\Single;
use Concrete\Package\ToessLabRobotsTxt\RobotTxt\RobotTxt;

defined('C5_EXECUTE') or die("Access Denied.");

class Controller extends Package {

    /**
     * @var string
     */
    protected $pkgHandle = 'toess_lab_robots_txt';

    /**
     * @var string
     */
    protected $appVersionRequired = '5.7.4';

    /**
     * @var string
     */
    protected $pkgVersion = '1.8.0';

    /**
     * @var Package
     */
    protected $pkg;

    /**
     * @var bool
     */
    protected $pkgAutoloaderMapCoreExtensions = true;

    /**
     * @return string
     */
    public function getPackageDescription()
    {
        return t("Edit robots.txt thru the dashboard");
    }

    /**
     * @return string
     */
    public function getPackageName()
    {
        return t("toesslab - robots.txt");
    }

    /**
     * @return \Concrete\Core\Entity\Package|void
     */
    public function install()
    {
        $this->pkg = parent::install();
        $this->getOrAddSinglePage('/dashboard/system/seo/edit_robots_txt', t('tösslab - solutions: Edit robots.txt'));
        $robotsTxt = new RobotTxt();
        $r = $this->app->make(\Concrete\Core\Http\Request::class);
        if ($r->request->get('install_robots_txt')) {
            $robotsTxt->checkOriginal();
        }
        $robotsTxt->saveOriginalToConfig('');
    }

    public function on_start()
    {
        $al = AssetList::getInstance();
        $pkg = $this;
        $al->register(
            'css', 'toess_lab_robots_txt', 'css/toess_lab_robots_txt.css', array('position' => Asset::ASSET_POSITION_HEADER), $pkg
        );
        $al->register(
            'javascript', 'toess_lab_robots_txt', 'js/toess_lab_robots_txt.min.js', array('position' => Asset::ASSET_POSITION_FOOTER), $pkg
        );
        $al->registerGroup('toess_lab_robots_txt', array(
            array('css', 'toess_lab_robots_txt'),
            array('javascript', 'toess_lab_robots_txt'),

        ));
    }

    /**
     * @param        $cPath
     * @param string $cName
     */
    private function getOrAddSinglePage($cPath, $cName = '') {
        $page = Page::getByPath($cPath);

        if (!$page || $page->isError()) {
            $single_page = Single::add($cPath, $this->pkg);
            $single_page->update([
                'cName' => $cName,
            ]);
        }
    }
}
